#!/usr/bin/env python
# tspApp_Grafik_Tkinter.py

# Quelle: Grafik_Tkinter_Grid.py
#© Claus Albowski

from tkinter import *
import _thread
import time
from tspGAKlasse import *
import tkinter.filedialog as fileDialog
fg,bg='black','white'
# fuer schwarzen Hintergrund umstellen:
##fg,bg='white','black'

class tspGraphApp(Frame):

    def __init__(self, master=None, breite=800, hoehe=800):
        '''breite und hoehe defineren die Abmessungen der Zeichenflaeche
        Vorgabe ist 500 x 500'''
        global staedte,schritte,pool,pMut,pCross
        staedte,schritte,pool,pMut,pCross = 10,10,10,30,30
        self.tspga = TSPGA()
        Frame.__init__(self, master)
        ### Frame-Bereich
        self.zeilen = 3
        self.spalten = 7
        self.grid()
        self.staedte = StringVar()           # Anzahl Staedte
        self.staedte.set(str(staedte))       # staedte globale Variable
        self.schritte = StringVar()
        self.schritte.set(str(schritte))
        self.pool = StringVar()
        self.pool.set(str(pool))
        self.pMut = StringVar()
        self.pMut.set(str(pMut))
        self.pCross = StringVar()
        self.pCross.set(str(pCross))
        self.wert = StringVar()
        self.wert.set('')
        self.breite = breite
        self.hoehe = hoehe
        self.createWidgets()


    def createWidgets(self):
        self.zeichenfenster = Canvas(self,height=self.breite,width=self.hoehe,bg=bg)
        self.zeichenfenster.grid(row=2, column=0, columnspan=7)
        self.zeichenfenster.bind("<Double-Button-1>", self.onBild)

        self.Label_S = Label(self, text="Staedte")
        self.Label_S.grid(row=0,column=0)
        
        self.Entry_S = Entry(self, textvariable=self.staedte, width=6)
        self.Entry_S.grid(row=1,column=0)

        self.Label_N = Label(self, text="Schritte")
        self.Label_N.grid(row=0,column=1)
        
        self.Entry_N = Entry(self, textvariable=self.schritte, width=6)
        self.Entry_N.grid(row=1, column=1)

        self.Label_P = Label(self, text="Pool")
        self.Label_P.grid(row=0,column=2)
        
        self.Entry_P = Entry(self, textvariable=self.pool, width=6)
        self.Entry_P.grid(row=1, column=2)

        self.Label_M = Label(self, text="Mutation(P)\n0..100 ")
        self.Label_M.grid(row=0,column=3)
        
        self.Entry_M = Entry(self, textvariable=self.pMut, width=6)
        self.Entry_M.grid(row=1,column=3)

        self.Label_C = Label(self, text="Cross-over (P)\n0..100 ")
        self.Label_C.grid(row=0,column=4)
        
        self.Entry_C = Entry(self, textvariable=self.pCross, width=6)
        self.Entry_C.grid(row=1,column=4)

        self.Button_C = Button(self, text="neu", command=self.zeichne, width=15)
        self.Button_C.grid(row=0, column=5, pady=3)

        self.Entry_W = Entry(self, textvariable=self.wert, width=15)
        self.Entry_W.grid(row=1,column=5)

        self.Button_G = Button(self, text="gleiche Staedte", command=self.wiederholt, width=15)
        self.Button_G.grid(row=0, column=6, pady=3)

        self.beenden_Button = Button(self, text= "Beenden", command=self.quit, width=15)
        self.beenden_Button.grid(row=1, column=6, pady=3)

    def onBild(self, evt=None):
        dateiname=fileDialog.asksaveasfilename(\
            parent=self,
            initialfile="Bild.ps",
            defaultextension='ps',
            initialdir='Bilder',
            title="Bild speichern")
        if dateiname in ['',()]: return
        self.zeichenfenster.postscript(file=dateiname)

    def zeichne(self):
        "zeichnet vollstaendig neu"
        staedte=int(self.staedte.get())
        pool=int(self.pool.get())
        schritte=int(self.schritte.get())
        pMut=int(self.pMut.get())
        pCross=int(self.pCross.get())
        self.tspga.gA_Neu(staedte,pool,schritte,pMut,pCross)
        ##genetischerAlgorithmus(poolGroesse, anzahlSchritte, pMut, pCross)
        ## Darstellung
        _thread.start_new_thread(self.Action, (0.5, 30))

    def wiederholt(self):
        "Zeichnet mit den alten Staedten"
        pool=int(self.pool.get())
        schritte=int(self.schritte.get())
        pMut=int(self.pMut.get())
        pCross=int(self.pCross.get())
        self.tspga.genetischerAlgorithmus(pool,schritte,pMut,pCross)
        _thread.start_new_thread(self.Action, (0.5, 30))
        
    def Action(self, sec, anzahl):
        """schrittweise wird ..."""
        zf=self.zeichenfenster
        zf.create_rectangle(0.0,0.0,self.breite,self.hoehe,fill=bg)
        self.Button_C.config(state=DISABLED)
        self.Button_G.config(state=DISABLED)
        daten = self.tspga.gibSchrittDaten()
        for einSchritt in daten:
            zf.delete('strecken')
            punkteListe,wert = einSchritt
            self.wert.set(str(wert))
            for j in range(len(punkteListe)):
                x1,y1=punkteListe[j]
                x2,y2=punkteListe[(j+1)%len(punkteListe)]
                zf.create_line(x1,y1,x2,y2,fill=fg,tag='strecken')
            time.sleep(sec)
        self.Button_C.config(state=NORMAL)
        self.Button_G.config(state=NORMAL)
        

### ---------------------------------------------------
if __name__ == '__main__':
    root = Tk()
    app = tspGraphApp(master=root)
    app.master.title('Grafik zu TSP')
    print('Bild speichern mit Doppelklick auf die Zeichenflaeche')
    app.mainloop()
    root.destroy()
